# cPy - Webserver showing time with auto refresh @ 2 seconds
# provided by Anthony Vogelaar, Perth Scotland
# rev 0.10  2025-02-27  initial release

import  platform
import  os;         os.system('clear')
import  time
from    string      import  Template
import  asyncio
from    microdot    import  Microdot, send_file
import  webbrowser

# =========================== local ================================

def openBrowser(port=5000):
    if platform.uname().machine == 'aarch64': pass
        #qpy:webapp:'R&D WebApp'                    # for QPython on Android
        #qpy://127.0.0.1:5000
    else: webbrowser.open(f'localhost:{port}', new=1)  # open een new browser window

# ========================== webserver =============================

def webServer(port=5000):
    app = Microdot()

    @app.route('/')
    async def index(request):
        t = time.strftime("%H:%M:%S")
        with open('static/index.html') as f:
            html = Template(f.read())
        return html.substitute(t=t), {'Content-Type': 'text/html'}


    @app.route('/static/<path:path>')
    async def static(request, path):
        if '..' in path:
            return 'Not found', 404                 # directory traversal is not allowed
        return send_file('static/' + path)


    return app

# ============================ Main ================================

class Main:

    def __init__(self, port=5000):
        self.port = port
        openBrowser()
        asyncio.run(self.aioInit())


    # launch all aio tasks
    async def aioInit(self):
        app = webServer()
        async with asyncio.TaskGroup() as tg:
            tg.create_task(app.start_server(port=self.port))
            tg.create_task(self._task())


    # monitor, print '*' @ 1 Hz
    async def _task(self):
        while True:
            print('*', end='', flush=True)
            await asyncio.sleep(1)


try:
    Main()
except KeyboardInterrupt:
    print('\nTerminated by Ctrl-C')

# ============================= end =================================
